const Chance = require('chance')
const { user, handlingEditor, answerHE } = require('./userData')
const { fragment, newVersion } = require('./fragments')
const { standardCollID } = require('./collectionIDs')

const chance = new Chance()
const collections = {
  collection: {
    id: standardCollID,
    title: chance.sentence(),
    type: 'collection',
    fragments: [fragment.id, newVersion.id],
    owners: [user.id],
    save: jest.fn(),
    invitations: [
      {
        id: chance.guid(),
        role: 'handlingEditor',
        hasAnswer: false,
        isAccepted: false,
        userId: handlingEditor.id,
        invitedOn: chance.timestamp(),
        respondedOn: null,
      },
      {
        id: chance.guid(),
        role: 'handlingEditor',
        hasAnswer: true,
        isAccepted: false,
        userId: answerHE.id,
        invitedOn: chance.timestamp(),
        respondedOn: chance.timestamp(),
      },
    ],
    handlingEditor: {
      id: handlingEditor.id,
      hasAnswer: false,
      isAccepted: false,
      email: handlingEditor.email,
      invitedOn: chance.timestamp(),
      respondedOn: null,
      name: `${handlingEditor.firstName} ${handlingEditor.lastName}`,
    },
  },
}

module.exports = collections
