const { heTeamID, revTeamID, authorTeamID } = require('./teamIDs')
const {
  handlingEditor,
  user,
  admin,
  author,
  reviewer,
  answerReviewer,
  submittingAuthor,
  recReviewer,
  answerHE,
} = require('./userData')
const Chance = require('chance')

const chance = new Chance()
const users = {
  admin: {
    type: 'user',
    username: 'admin',
    email: admin.email,
    firstName: admin.firstName,
    lastName: admin.lastName,
    password: 'test',
    admin: true,
    id: admin.id,
  },
  editorInChief: {
    type: 'user',
    username: chance.word(),
    email: chance.email(),
    password: 'password',
    admin: false,
    id: chance.guid(),
    firstName: chance.first(),
    lastName: chance.last(),
    affiliation: chance.company(),
    title: 'Mr',
    save: jest.fn(() => users.editorInChief),
    isConfirmed: false,
    editorInChief: true,
  },
  handlingEditor: {
    type: 'user',
    username: chance.word(),
    email: handlingEditor.email,
    password: 'password',
    admin: false,
    id: handlingEditor.id,
    firstName: handlingEditor.firstName,
    lastName: handlingEditor.lastName,
    teams: [heTeamID],
    save: jest.fn(() => users.handlingEditor),
    editorInChief: false,
    handlingEditor: true,
    title: 'Mr',
  },
  answerHE: {
    type: 'user',
    username: chance.word(),
    email: answerHE.email,
    password: 'password',
    admin: false,
    id: answerHE.id,
    firstName: answerHE.firstName,
    lastName: answerHE.lastName,
    teams: [heTeamID],
    save: jest.fn(() => users.answerHE),
    editorInChief: false,
    handlingEditor: true,
    title: 'Mr',
  },
  user: {
    type: 'user',
    username: chance.word(),
    email: user.email,
    password: 'password',
    admin: false,
    id: user.id,
    passwordResetToken: chance.hash(),
    firstName: user.firstName,
    lastName: user.lastName,
    affiliation: chance.company(),
    title: 'Mr',
    save: jest.fn(() => users.user),
    isConfirmed: false,
    updateProperties: jest.fn(() => users.user),
    teams: [],
  },
  author: {
    type: 'user',
    username: chance.word(),
    email: author.email,
    password: 'password',
    admin: false,
    id: author.id,
    firstName: author.firstName,
    lastName: author.lastName,
    affiliation: chance.company(),
    title: 'Mr',
    save: jest.fn(() => users.author),
    isConfirmed: true,
    passwordResetToken: chance.hash(),
    teams: [authorTeamID],
  },
  reviewer: {
    type: 'user',
    username: chance.word(),
    email: reviewer.email,
    password: 'password',
    admin: false,
    id: reviewer.id,
    firstName: reviewer.firstName,
    lastName: reviewer.lastName,
    affiliation: chance.company(),
    title: 'Mr',
    save: jest.fn(() => users.reviewer),
    isConfirmed: true,
    teams: [revTeamID],
    invitationToken: 'inv-token-123',
  },
  answerReviewer: {
    type: 'user',
    username: chance.word(),
    email: answerReviewer.email,
    password: 'password',
    admin: false,
    id: answerReviewer.id,
    firstName: answerReviewer.firstName,
    lastName: answerReviewer.lastName,
    affiliation: chance.company(),
    title: 'Dr',
    save: jest.fn(() => users.answerReviewer),
    isConfirmed: true,
    teams: [revTeamID],
    invitationToken: 'inv-token-123',
  },
  submittingAuthor: {
    type: 'user',
    username: 'sauthor',
    email: submittingAuthor.email,
    password: 'password',
    admin: false,
    id: submittingAuthor.id,
    passwordResetToken: chance.hash(),
    firstName: submittingAuthor.firstName,
    lastName: submittingAuthor.lastName,
    affiliation: chance.company(),
    title: 'Mr',
    save: jest.fn(() => users.submittingAuthor),
    isConfirmed: false,
  },
  recReviewer: {
    type: 'user',
    username: chance.word(),
    email: recReviewer.email,
    password: 'password',
    admin: false,
    id: recReviewer.id,
    firstName: recReviewer.firstName,
    lastName: recReviewer.lastName,
    affiliation: chance.company(),
    title: 'Mr',
    save: jest.fn(() => users.recReviewer),
    isConfirmed: true,
    teams: [revTeamID],
  },
}

module.exports = users
